Index: Jamroot
===================================================================
--- Jamroot	(revision 43126)
+++ Jamroot	(working copy)
@@ -149,7 +149,31 @@
     }
 }
 
+local PLATFORM_DEFS ;
 
+if [ os.name ] = NT
+{
+  local argv = [ modules.peek : ARGV ] ;
+  local show-warnings = [ MATCH --show-(all-warnings) : $(argv) ] ;
+
+  if $(show-warnings)
+  {
+    ECHO "note: Showing MS \'unsafe stdlib\' warnings." ;
+  }
+  else
+  {
+    ECHO "warning: Building without MS \'unsafe stdlib\' warnings." ;
+    ECHO "warning: Pass \"--show-all-warnings\" on the command line to disable this." ;
+
+    PLATFORM_DEFS =
+      <toolset>msvc-8.0:<define>_CRT_SECURE_NO_DEPRECATE
+      <toolset>msvc-9.0:<define>_CRT_SECURE_NO_WARNINGS
+      <toolset>msvc-8.0:<define>_SCL_SECURE_NO_DEPRECATE
+      <toolset>msvc-9.0:<define>_SCL_SECURE_NO_WARNINGS
+    ;
+  }
+}
+
 project boost
     : requirements <include>.
       # disable auto-linking for all targets here,
@@ -159,6 +183,7 @@
       # 'tag' rule below.
       <tag>@$(__name__).tag
       <conditional>@handle-static-runtime
+      $(PLATFORM_DEFS)
             
     : usage-requirements <include>.
     : build-dir bin.v2
